//*****************************************************************************************

//Starter Web Interface v2.1

//Copyright (c) 2018 Pharos Architectural Controls Limited. All rights reserved.

//This sample content is made freely available for illustrative purposes only. Pharos Architectural Controls grants a non-exclusive copyright licence to use this sample content from which you can
//generate content tailored to your own specific needs for use with products from Pharos Architectural Controls. This sample content has not been thoroughly tested under all conditions and Pharos
//Architectural Controls cannot guarantee reliability or serviceability.

//This sample content is provided "as is" without warranties of any kind. The implied warranties of non-infringement, merchantability and fitness for a particular purpose are expressly
//disclaimed. In no event shall Pharos Architectural Controls be liable to any party for direct, indirect, incidental or consequential damages arising from the use of this sample content.

//For further information please contact support@pharoscontrols.com.

//*****************************************************************************************


// Set whether or not all of the accordions can be closed at once.  Set to 'false' to have at least one section open at all times.
var collapsed = true;


// Define global variables
var iGroup = 0;
var uGroup = 0;
var accOpen = 0;
var sccOpen = 0;




// Function to update slider values
function updateSliders() {
	Query.get_group_info(function (t) {
		for (var i = 0; i < Object.keys(t.groups).length; i++) {
			$('#slider' + t.groups[i].num).slider("option", "value", t.groups[i].level);
			$('#amount').val(t.groups[i].level);
		}
	});
}


// Function that builds the timeline page and accordion
function timelines() {
	Query.get_timeline_info(function (t) {
		
	function predicatBy(prop){
   		return function(a,b){
      		if( a[prop] > b[prop]){
          return 1;
      }else if( a[prop] < b[prop] ){
          return -1;
      }
      return 0;
   };
}

//Usage
t.timelines.sort( predicatBy("num") );

		var tlNum = Object.keys(t.timelines).length;
		var accNum = Math.floor(parseInt(tlNum, 10) / parseInt(9, 10) + 1);
		var accSub = [];
		if (tlNum === 0) {
			$('#page1').remove();
			$('#timelines').remove();
		} else if (tlNum > 9) {
			
			for (var i = 1; i <= accNum; i++) {
				var tlEnd = Math.floor(i * 9);
				var tlStart = Math.floor(tlEnd - 8);
				$('.buttons').append('<div class="accTop accTop' + i + '"  onclick="header(' + i + ')">Timelines ' + i + '</div><div class="clear accSub accSub' + i + '" ></div>');
			}
			var lop = 1;
			var set = 1;
			for (var k = 0; k < tlNum; k++) {
				$('.accSub' + set).append('<div onclick="start_timeline(' + t.timelines[k].num + ')" class="btn2" id="timeline' + t.timelines[k].num + '">' + t.timelines[k]["name"] + '</div>');
					if (lop == 9) {
						set = set + 1;
						lop = 1;
					} else {
						lop = lop + 1;
					}
				
			}
			
		} else if (tlNum < 10) {
			for (var j = 0; j < tlNum; j++) {
				$('.buttons').append('<div onclick="start_timeline(' + t.timelines[j].num + ')" class="btn2" id="timeline' + t.timelines[j].num + '">' + t.timelines[j]["name"] + '</div>');
			}
		}
		for (var p = 0; p < tlNum; p++) {
			if (t.timelines[p].onstage == true) {
				$('#timeline' + t.timelines[p].num).addClass('active');
				$('.off').removeClass('off_active');
				
			
			} else {
				$('#timeline' + t.timelines[p].num).removeClass('active');
			}
		}
		$('.accSub').slideUp();
		if($('.accSub').children().hasClass('active')){
		$('.active').parent().slideDown().css('display', 'inline-block');
		} else {
			$('.accSub1').slideDown().css('display', 'inline-block');
		}
		if ($('.accSub').children().hasClass('active')) {
		document.location = "index.html#page1";
	}
	});
	
}


// Function that builds the scene page and accordion
function scenes() {
	Query.get_scene_info(function (t) {
		function predicatBy(prop){
   return function(a,b){
      if( a[prop] > b[prop]){
          return 1;
      }else if( a[prop] < b[prop] ){
          return -1;
      }
      return 0;
   };
}

//Usage
t.scenes.sort( predicatBy("num") );
		var scNum = Object.keys(t.scenes).length;
		var accNum = Math.floor(parseInt(scNum, 10) / parseInt(9, 10) + 1);
		if (scNum === 0) {
			$('#page2').remove();
			$('#scenes').remove();
		} else if (scNum > 9) {
			
			for (var i = 1; i <= accNum; i++) {
				var scEnd = Math.floor(i * 9);
				var scStart = Math.floor(scEnd - 8);
				$('.scenes').append('<div class="accSCtop accSCtop' + i + '" onclick="accSCsub(' + i + ')">Scenes ' + i + '</div><div class="clear accSCsub' + i + ' accSCsub"></div>');
			}
			var lop = 1;
			var set = 1;
			for (var k = 0; k < scNum; k++) {
									$('.accSCsub' + set).append('<div onclick="start_scene(' + t.scenes[k].num + ')" class="btn2" id="scene' + t.scenes[k].num + '">' + t.scenes[k]["name"] + '</div>');
			if (lop == 9) {
						set = set + 1;
						lop = 1;
					} else {
						lop = lop + 1;
					}
				
			}
		} else if (scNum < 10) {
			for (var j = 0; j < scNum; j++) {
				$('.scenes').append('<div onclick="start_scene(' + t.scenes[j].num + ')" class="btn2" id="scene' + t.scenes[j].num + '">' + t.scenes[j]["name"] + '</div>');
			}
		}
		for (var p = 0; p < scNum; p++) {
			if (t.scenes[p].onstage == true) {
				$('#scene' + t.scenes[p].num).addClass('active');
				$('.off').removeClass('off_active');
			} else {
				$('#scene' + t.scenes[p].num).removeClass('active');
			}
		}
		$('.accSCsub').slideUp();
		if($('.accSCsub').children().hasClass('active')){
		$('.active').parent().slideDown().css('display', 'inline-block');
		} else {
			$('.accSCsub1').slideDown().css('display', 'inline-block');
		}
		
		if ($('.accSCsub').children().hasClass('active')) {
		document.location = "index.html#page2";
		$('.footerBtn').removeClass('footerBtn_active');
		$('.icon').removeClass('icon_active');
		$('.sc').addClass('footerBtn_active');
		$('.sc').children('.icon').addClass('icon_active');
	}
	});
}

// Function that builds the groups select menu for the color picker
function groups() {
	Query.get_group_info(function (t) {
		
		var grNum = Object.keys(t.groups).length;
		for (var k = 1; k < grNum; k++) {
			if (t.groups[k].num > 0 && t.groups[k].num !== null) {
				$('#pickerGroups').append('<option id="' + t.groups[k].num + '">' + t.groups[k]["name"] + '</option>');
				$('#intensityGroups').append('<option id="group' + t.groups[k].num + '">' + t.groups[k]["name"] + '</option>');
				$('.i_column_wrap').append('<div class="slider_title">' + t.groups[k]["name"] + '<br><div class="sliderbg" align="center"><div align="center" class="slider" id="slider' + t.groups[k].num + '"></div></div><div><input class="amount" id="amount' + t.groups[k].num + '" readonly type="text"></div>');
				$('body').append('<script>$(function() {$("#slider' + t.groups[k].num + '").slider({orientation: "horizontal",range: "min", min: 0, max: 100, value: 100, step: 1,slide: function(change, ui) {$("#amount' + t.groups[k].num + '").val(ui.value);INTthrottled' + t.groups[k].num + '(ui.value);}});$("#amount' + t.groups[k].num + '").val($("#slider' + t.groups[k].num + '").slider("value"));});function sendINT' + t.groups[k].num + '(int) {var newInt = Math.floor(int * 2.55);Query.run_command({"input":"get_group(' + t.groups[k].num + '):set_master_intensity(" + newInt + ")"});}var INTthrottled' + t.groups[k].num + ' = $.throttle(100, sendINT' + t.groups[k].num + ');</script>');
			}
		}
	});
}

//  Calling functions to build pages
timelines();
scenes();
groups();


// Subscription to update scene buttons
Query.subscribe_scene_status(function (r) {
	if (r.onstage === true) {
		$('#scene' + r.num).addClass('active');
	} else {
		$('#scene' + r.num).removeClass('active');
	}
});

// Subscription to update timeline buttons
Query.subscribe_timeline_status(function (q) {
	if (q.state === "holding_at_end" || q.state === "running") {
		$('#timeline' + q.num).addClass('active');
	} else {
		$('#timeline' + q.num).removeClass('active');
	}
});

// Function that starts timelines
function start_timeline(num) {
	Query.run_command({"input": 'release_all(0) get_timeline(' + num + '):start()'});
	$('#page5 > svg').remove();
	setCP();
}

// Function that starts scenes
function start_scene(num) {
	Query.run_command({"input":'release_all(2) get_scene(' + num + '):start()'});
	$('#page5 > svg').remove();
	setCP();
}

// Function for the off button
function off() {
	Query.run_command({"input":'release_all()'});
	$('.slider').slider("option", "value", 100);
	$(".amount").val(100);
	Query.get_group_info(function (t) {
	var grNum = Object.keys(t.groups).length;
		for (var k = 1; k < grNum; k++) {
		Query.run_command({"input":'get_group(' + t.groups[k].num + '):set_master_intensity(255, 2)'});
		
		}
	});
}

//accordion functions
function header(num) {
	$('.accSub').slideUp();
			if($(".accTop" + num).next().is(":visible")) {
			$(".accTop" + num).next().slideUp();
			} else {
			$(".accTop" + num).next().slideDown().css('display', 'inline-block');	
			}
}

function accSCsub(num) {
	$('.accSCsub').slideUp();
			if($(".accSCtop" + num).next().is(":visible")) {
			$(".accSCtop" + num).next().slideUp();
			} else {
			$(".accSCtop" + num).next().slideDown().css('display', 'inline-block');	
			}
}

$(document).ready(function () {
			
	// Help button functions
	$('.help').click(function () {
		$('.footerBtn').removeClass('footerBtn_active');
		$('.icon').removeClass('icon_active');
	});
	
	
	
	// Footer button function
	$('.footerBtn').click(function () {
		$(this).addClass('footerBtn_active');
		$(this).children('.icon').addClass('icon_active');
		$('.footerBtn').not(this).children('.icon').removeClass('icon_active');
		$('.footerBtn').not(this).removeClass('footerBtn_active');
	});
	
	
	// Fucntion to update sliders when intensity button is selected
	$('.is').click(function () {
		updateSliders();
	});
	//openACC();
	
	
	
});
